var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from 'react';
import { connect } from 'react-redux';

import { compose, setPropTypes } from 'recompose';
import PropTypes from 'prop-types';

var mapStateToProps = function mapStateToProps(_ref) {
    var connection = _ref.connection,
        messageQueue = _ref.messages.messageQueue,
        config = _ref.config;
    return {
        connection: connection,
        typing: messageQueue.length,
        avatar: config.avatar
    };
};

var enhance = compose(setPropTypes({
    connection: PropTypes.object,
    typing: PropTypes.bool
}), connect(mapStateToProps));

export var AvatarContainer = function AvatarContainer(_ref2) {
    var AvatarComponent = _ref2.AvatarComponent,
        avatar = _ref2.avatar,
        connection = _ref2.connection,
        typing = _ref2.typing;

    return React.createElement(
        'div',
        null,
        React.createElement(AvatarComponent, _extends({ avatar: avatar }, connection, { typing: typing }))
    );
};

export default enhance(AvatarContainer);