// @ts-check
import React from 'react';
import { connect } from 'react-redux';
import PropTypes from 'prop-types';
import { compose, setPropTypes } from 'recompose';

import MessageList from '../MessageList';
import InputArea from '../InputArea';

var mapStateToProps = function mapStateToProps(_ref) {
    var connection = _ref.connection;

    return { connection: connection };
};

var enhance = compose(setPropTypes({
    theme: PropTypes.shape({
        ImageComponent: PropTypes.oneOfType([PropTypes.element, PropTypes.func]),
        InputComponent: PropTypes.oneOfType([PropTypes.element, PropTypes.func]),
        MessageComponent: PropTypes.oneOfType([PropTypes.element, PropTypes.func]),
        TextComponent: PropTypes.oneOfType([PropTypes.element, PropTypes.func])
    })
}), connect(mapStateToProps));

export var ChatContainer = function ChatContainer(_ref2) {
    var theme = _ref2.theme,
        connection = _ref2.connection;

    return React.createElement(
        'div',
        { className: 'ChatContainer' },
        React.createElement(MessageList, { theme: theme }),
        React.createElement(InputArea, theme)
    );
};

export default enhance(ChatContainer);