var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from 'react';
import PropTypes from 'prop-types';
import { compose, setPropTypes } from 'recompose';
import { ButtonContainer } from '../ButtonContainer';

var enhance = compose(setPropTypes({
    page: PropTypes.object,
    isLocal: PropTypes.bool,
    ImageComponent: PropTypes.oneOfType([PropTypes.element, PropTypes.func]),
    InputComponent: PropTypes.oneOfType([PropTypes.element, PropTypes.func]),
    MessageComponent: PropTypes.oneOfType([PropTypes.element, PropTypes.func]),
    TextComponent: PropTypes.oneOfType([PropTypes.element, PropTypes.func]),
    ButtonComponent: PropTypes.oneOfType([PropTypes.element, PropTypes.func])
}));

export var Message = function Message(_ref) {
    var page = _ref.page,
        isLocal = _ref.isLocal,
        ImageComponent = _ref.ImageComponent,
        InputComponent = _ref.InputComponent,
        MessageComponent = _ref.MessageComponent,
        TextComponent = _ref.TextComponent,
        ButtonComponent = _ref.ButtonComponent,
        submitHandler = _ref.submitHandler;

    return [React.createElement(
        TextComponent,
        { key: 'text', isLocal: isLocal },
        page.text
    ), page.image && React.createElement(ImageComponent, _extends({ key: 'image' }, page.image)), page.buttons && page.buttons.length > 0 && React.createElement(
        ButtonContainer,
        { key: 'buttons' },
        page.buttons.map(function (button, i) {
            return React.createElement(ButtonComponent, _extends({
                key: 'button-' + i
            }, button, {
                onClick: function onClick() {
                    return submitHandler({
                        postback: button.postback,
                        text: button.text
                    });
                }
            }));
        })
    )];
};

export default enhance(Message);