function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import Slider from 'react-slick';

var layoutClasses = {
    plain: 'MessageContainer',
    list: 'ListContainer',
    carousel: 'CarouselContainer'
};

// TODO: Test browser resizing
var sliderSettings = {
    dots: true,
    infinite: true,
    speed: 500,
    slidesToShow: 1,
    slidesToScroll: 1,
    nextArrow: React.createElement('button', { className: 'slick-next' }),
    prevArrow: React.createElement('button', { className: 'slick-next' })
};

var MessageContainer = function MessageContainer(_ref) {
    var userId = _ref.userId,
        type = _ref.type,
        children = _ref.children,
        layout = _ref.layout,
        origin = _ref.origin,
        pages = _ref.pages,
        rest = _objectWithoutProperties(_ref, ['userId', 'type', 'children', 'layout', 'origin', 'pages']);

    var hasSelectedInput = rest.selectedInput !== undefined && rest.selectedInput !== null;

    return React.createElement(
        'div',
        {
            className: (layoutClasses[layout] || 'MessageContainer') + ' ' + (origin === 'local' ? 'is-local' : '')
        },
        layout === 'carousel' ? React.createElement(
            Slider,
            sliderSettings,
            React.Children.map(children, function (child) {
                return React.createElement(
                    'div',
                    { className: 'CarouselContainer-item' },
                    child
                );
            })
        ) : children
    );
};

export default MessageContainer;