var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

// @ts-check
import { MESSAGE_ADD, MESSAGE_QUEUE } from '../actionTypes';
import { MESSAGE_RECEIVE } from '../../es/actionTypes';

var initialState = {
    messages: [],
    messageQueue: []
};
/**
 * @ignore
 */
export default (function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
    var action = arguments[1];

    switch (action.type) {
        case MESSAGE_ADD:
            return _extends({}, state, {
                messages: [].concat(state.messages, [_extends({}, action.payload, {
                    timeAdded: Date.now()
                })]),
                messageQueue: state.messageQueue.filter(function (message) {
                    return message.message !== action.payload;
                })
            });
        case MESSAGE_QUEUE:
            return _extends({}, state, {
                messageQueue: [].concat(state.messageQueue, action.payload)
            });
        default:
            return state;
    }
});