// @ts-check
import { createStore, applyMiddleware, compose } from 'redux';
import thunk from 'redux-thunk';

import { reducers } from './reducers/index';
import eventEmitterMiddleware from './middleware/eventEmitter';

var middlewares = [eventEmitterMiddleware, thunk];

var middleware = applyMiddleware.apply(undefined, middlewares);

if (window.devToolsExtension) {
    middleware = compose(middleware, window.devToolsExtension());
}

export default createStore(reducers, middleware);
export var createStoreWithState = function createStoreWithState(initialState) {
    return createStore(reducers, initialState, middleware);
};