//@ts-check
import React from 'react';
import PropTypes from 'prop-types';
import { compose, setPropTypes } from 'recompose';

var enhance = compose(setPropTypes({
    text: PropTypes.string,
    phone: PropTypes.string,
    url: PropTypes.string,
    onClick: PropTypes.func
}));

/**
 * A simple button component
 * @param {Object} param
 * @param {number} param.text - text to be rendered inside button.
 * @param {function(e: Object)} param.onClick - click handler function
 * @return {Object} React component
 */
export var Button = function Button(_ref) {
    var text = _ref.text,
        phone = _ref.phone,
        url = _ref.url,
        onClick = _ref.onClick;
    return phone || url ? React.createElement(
        'a',
        {
            className: 'Button Button--solid',
            target: '_blank',
            href: phone ? 'tel:' + phone : url
        },
        text
    ) : React.createElement(
        'button',
        { className: 'Button Button--solid', onClick: onClick },
        text
    );
};

export default enhance(Button);