'use strict';

exports.__esModule = true;
exports.listening = exports.dropped = exports.attempted = exports.established = undefined;

var _actionTypes = require('../actionTypes');

/**
 * Sets connection to established
 * @return {{type: CONNECTION_ESTABLISHED}} redux action type returned
 */
var established = exports.established = function established(_) {
    return {
        type: _actionTypes.CONNECTION_ESTABLISHED
    };
};

/**
 * Sets connection to attempted
 * @return {{type: CONNECTION_ATTEMPTED}} redux action type returned
 */
var attempted = exports.attempted = function attempted(_) {
    return {
        type: _actionTypes.CONNECTION_ATTEMPTED
    };
};

/**
 * Sets connection to offline
 * @return {{type: CONNECTION_DROPPED}} redux action type returned
 */
var dropped = exports.dropped = function dropped(_) {
    return {
        type: _actionTypes.CONNECTION_DROPPED
    };
};

/**
 * Sets connection to listening
 * @return {{type: CONNECTION_LISTENING}} redux action type returned
 */
var listening = exports.listening = function listening(_) {
    return {
        type: _actionTypes.CONNECTION_LISTENING
    };
};