'use strict';

exports.__esModule = true;
exports.AvatarContainer = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _recompose = require('recompose');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var mapStateToProps = function mapStateToProps(_ref) {
    var connection = _ref.connection,
        messageQueue = _ref.messages.messageQueue,
        config = _ref.config;
    return {
        connection: connection,
        typing: messageQueue.length,
        avatar: config.avatar
    };
};

var enhance = (0, _recompose.compose)((0, _recompose.setPropTypes)({
    connection: _propTypes2.default.object,
    typing: _propTypes2.default.bool
}), (0, _reactRedux.connect)(mapStateToProps));

var AvatarContainer = exports.AvatarContainer = function AvatarContainer(_ref2) {
    var AvatarComponent = _ref2.AvatarComponent,
        avatar = _ref2.avatar,
        connection = _ref2.connection,
        typing = _ref2.typing;

    return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(AvatarComponent, _extends({ avatar: avatar }, connection, { typing: typing }))
    );
};

exports.default = enhance(AvatarContainer);