'use strict';

exports.__esModule = true;
exports.Message = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _recompose = require('recompose');

var _ButtonContainer = require('../ButtonContainer');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var enhance = (0, _recompose.compose)((0, _recompose.setPropTypes)({
    page: _propTypes2.default.object,
    isLocal: _propTypes2.default.bool,
    ImageComponent: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.func]),
    InputComponent: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.func]),
    MessageComponent: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.func]),
    TextComponent: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.func]),
    ButtonComponent: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.func])
}));

var Message = exports.Message = function Message(_ref) {
    var page = _ref.page,
        isLocal = _ref.isLocal,
        ImageComponent = _ref.ImageComponent,
        InputComponent = _ref.InputComponent,
        MessageComponent = _ref.MessageComponent,
        TextComponent = _ref.TextComponent,
        ButtonComponent = _ref.ButtonComponent,
        submitHandler = _ref.submitHandler;

    return [_react2.default.createElement(
        TextComponent,
        { key: 'text', isLocal: isLocal },
        page.text
    ), page.image && _react2.default.createElement(ImageComponent, _extends({ key: 'image' }, page.image)), page.buttons && page.buttons.length > 0 && _react2.default.createElement(
        _ButtonContainer.ButtonContainer,
        { key: 'buttons' },
        page.buttons.map(function (button, i) {
            return _react2.default.createElement(ButtonComponent, _extends({
                key: 'button-' + i
            }, button, {
                onClick: function onClick() {
                    return submitHandler({
                        postback: button.postback,
                        text: button.text
                    });
                }
            }));
        })
    )];
};

exports.default = enhance(Message);