'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactSlick = require('react-slick');

var _reactSlick2 = _interopRequireDefault(_reactSlick);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var layoutClasses = {
    plain: 'MessageContainer',
    list: 'ListContainer',
    carousel: 'CarouselContainer'
};

// TODO: Test browser resizing
var sliderSettings = {
    dots: true,
    infinite: true,
    speed: 500,
    slidesToShow: 1,
    slidesToScroll: 1,
    nextArrow: _react2.default.createElement('button', { className: 'slick-next' }),
    prevArrow: _react2.default.createElement('button', { className: 'slick-next' })
};

var MessageContainer = function MessageContainer(_ref) {
    var userId = _ref.userId,
        type = _ref.type,
        children = _ref.children,
        layout = _ref.layout,
        origin = _ref.origin,
        pages = _ref.pages,
        rest = _objectWithoutProperties(_ref, ['userId', 'type', 'children', 'layout', 'origin', 'pages']);

    var hasSelectedInput = rest.selectedInput !== undefined && rest.selectedInput !== null;

    return _react2.default.createElement(
        'div',
        {
            className: (layoutClasses[layout] || 'MessageContainer') + ' ' + (origin === 'local' ? 'is-local' : '')
        },
        layout === 'carousel' ? _react2.default.createElement(
            _reactSlick2.default,
            sliderSettings,
            _react2.default.Children.map(children, function (child) {
                return _react2.default.createElement(
                    'div',
                    { className: 'CarouselContainer-item' },
                    child
                );
            })
        ) : children
    );
};

exports.default = MessageContainer;
module.exports = exports['default'];