'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; // @ts-check


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _AvatarContainer = require('../AvatarContainer');

var _AvatarContainer2 = _interopRequireDefault(_AvatarContainer);

var _MessageContainer = require('../MessageContainer');

var _MessageContainer2 = _interopRequireDefault(_MessageContainer);

var _Message = require('../Message');

var _Message2 = _interopRequireDefault(_Message);

var _messages = require('../../actions/messages');

var messageActions = _interopRequireWildcard(_messages);

var _index = require('../../../es/themes/default/components/Avatar/index');

var _index2 = _interopRequireDefault(_index);

var _network = require('../../../es/utils/network');

var _network2 = _interopRequireDefault(_network);

var _index3 = require('../../../es/themes/default/components/TypingIndicator/index');

var _index4 = _interopRequireDefault(_index3);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var mapStateToProps = function mapStateToProps(_ref) {
    var messages = _ref.messages,
        config = _ref.config;
    return {
        messages: messages.messages,
        messageQueue: messages.messageQueue,
        config: config
    };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch, ownProps) {
    return {
        submitHandler: function submitHandler(message) {
            dispatch(messageActions.messageSend(_extends({}, message, {
                type: 'button'
            })));
        }
    };
};

var MessageList = function (_React$Component) {
    _inherits(MessageList, _React$Component);

    function MessageList(props) {
        _classCallCheck(this, MessageList);

        var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

        _this.state = {
            offset: 0
        };
        return _this;
    }

    MessageList.prototype.componentDidUpdate = function componentDidUpdate() {
        this._last && this._last.scrollIntoView({
            behavior: 'smooth',
            block: 'end',
            inline: 'end'
        });

        // let { messageQueue, delayedMessageAdd } = this.props;

        // messageQueue.length && delayedMessageAdd(messageQueue[messageQueue.length - 1]);
    };

    MessageList.prototype.render = function render() {
        var _this2 = this;

        var _props = this.props,
            theme = _props.theme,
            messages = _props.messages,
            messageQueue = _props.messageQueue,
            submitHandler = _props.submitHandler,
            config = _props.config;

        return _react2.default.createElement(
            'ul',
            {
                className: 'ChatContainer-content',
                ref: function ref(_ref3) {
                    return _this2._ref = _ref3;
                }
            },
            _react2.default.createElement(
                'div',
                { className: 'MessagesList' },
                messages.map(function (message, i) {
                    return _react2.default.createElement(
                        'li',
                        {
                            key: i,
                            ref: function ref(_ref2) {
                                if (i === messages.length - 1) {
                                    _this2._last = _ref2;
                                }
                            }
                        },
                        message.origin === 'remote' && (messages[i - 1] ? messages[i - 1].origin !== 'remote' : true) && _react2.default.createElement(_AvatarContainer2.default, {
                            AvatarComponent: theme.AvatarComponent
                        }),
                        _react2.default.createElement(
                            _MessageContainer2.default,
                            _extends({ key: 'text' }, message),
                            message.origin === 'remote' ? message.pages.map(function (page, i) {
                                return _react2.default.createElement(_Message2.default, _extends({
                                    key: i,
                                    page: page,
                                    isLocal: message.origin === 'local'
                                }, theme, {
                                    submitHandler: submitHandler
                                }));
                            }) : _react2.default.createElement(_Message2.default, _extends({
                                key: i,
                                page: { text: message.text },
                                isLocal: true
                            }, theme))
                        ),
                        ' ',
                        message.buttons && message.buttonStyle === 'default' && _react2.default.createElement(
                            _MessageContainer2.default,
                            _extends({
                                key: 'buttons'
                            }, message),
                            message.buttons.map(function (button, i) {
                                return _react2.default.createElement(theme.ButtonComponent, {
                                    key: i,
                                    text: button.text,
                                    phone: button.phone,
                                    url: button.url,
                                    onClick: function onClick() {
                                        return submitHandler({
                                            postback: button.postback,
                                            text: button.text
                                        });
                                    }
                                });
                            })
                        ),
                        messageQueue.length && i === messages.length - 1 && config.typingStatus.active ? [_react2.default.createElement(
                            _MessageContainer2.default,
                            { key: 'typing' },
                            _react2.default.createElement(theme.TypingIndicatorComponent, config.TypingIndicator)
                        )] : null
                    );
                })
            )
        );
    };

    return MessageList;
}(_react2.default.Component);

MessageList.PropTypes = {
    messages: _propTypes2.default.object,
    theme: _propTypes2.default.shape({
        ImageComponent: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.func]),
        InputComponent: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.func]),
        MessageComponent: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.func]),
        TextComponent: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.func])
    }),
    config: _propTypes2.default.object
};

exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(MessageList);
module.exports = exports['default'];