'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; // @ts-check


var _actionTypes = require('../actionTypes');

var _actionTypes2 = require('../../es/actionTypes');

var initialState = {
    messages: [],
    messageQueue: []
};
/**
 * @ignore
 */

exports.default = function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
    var action = arguments[1];

    switch (action.type) {
        case _actionTypes.MESSAGE_ADD:
            return _extends({}, state, {
                messages: [].concat(state.messages, [_extends({}, action.payload, {
                    timeAdded: Date.now()
                })]),
                messageQueue: state.messageQueue.filter(function (message) {
                    return message.message !== action.payload;
                })
            });
        case _actionTypes.MESSAGE_QUEUE:
            return _extends({}, state, {
                messageQueue: [].concat(state.messageQueue, action.payload)
            });
        default:
            return state;
    }
};

module.exports = exports['default'];