'use strict';

exports.__esModule = true;
exports.Button = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _recompose = require('recompose');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var enhance = (0, _recompose.compose)((0, _recompose.setPropTypes)({
    text: _propTypes2.default.string,
    phone: _propTypes2.default.string,
    url: _propTypes2.default.string,
    onClick: _propTypes2.default.func
}));

/**
 * A simple button component
 * @param {Object} param
 * @param {number} param.text - text to be rendered inside button.
 * @param {function(e: Object)} param.onClick - click handler function
 * @return {Object} React component
 */
//@ts-check
var Button = exports.Button = function Button(_ref) {
    var text = _ref.text,
        phone = _ref.phone,
        url = _ref.url,
        onClick = _ref.onClick;
    return phone || url ? _react2.default.createElement(
        'a',
        {
            className: 'Button Button--solid',
            target: '_blank',
            href: phone ? 'tel:' + phone : url
        },
        text
    ) : _react2.default.createElement(
        'button',
        { className: 'Button Button--solid', onClick: onClick },
        text
    );
};

exports.default = enhance(Button);