'use strict';

exports.__esModule = true;
exports.ImageComponent = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _recompose = require('recompose');

var _Infinity = require('../../icons/Infinity.svg');

var _Infinity2 = _interopRequireDefault(_Infinity);

var _index = require('../Animation/index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// @ts-check
var enhance = (0, _recompose.compose)((0, _recompose.setPropTypes)({
    url: _propTypes2.default.string.isRequired,
    text: _propTypes2.default.string,
    width: _propTypes2.default.number,
    height: _propTypes2.default.number
}), (0, _recompose.withState)('loaded', 'setLoaded', false), (0, _recompose.lifecycle)({
    componentDidMount: function componentDidMount(props) {
        var _this = this;

        var image = new Image(0, 0);
        image.src = this.props.url;
        image.addEventListener('load', function () {
            _this.setState({ loaded: true });
        });
    }
}));

/**
 * An image
 * @param {Object} param
 * @param {string} param.url - image url
 * @param {number} param.width - width of the image in pixels
 * @param {number} param.height - height of the image in pixels
 * @return {Object} React component
 */

var ImageComponent = exports.ImageComponent = function ImageComponent(_ref) {
    var url = _ref.url,
        text = _ref.text,
        loaded = _ref.loaded,
        _ref$height = _ref.height,
        height = _ref$height === undefined ? 200 : _ref$height;

    return _react2.default.createElement(
        _index.Fade,
        { 'in': true, appear: true },
        _react2.default.createElement(
            'div',
            { className: 'Image' },
            loaded ? _react2.default.createElement('img', { className: 'Image-image', src: url }) : _react2.default.createElement(
                'div',
                { className: 'Image-loader', style: { height: height } },
                _react2.default.createElement('img', { className: 'Image-loaderIcon', src: _Infinity2.default })
            ),
            text && _react2.default.createElement('p', { className: 'Image-text Text', dangerouslySetInnerHTML: { __html: text } })
        )
    );
};

exports.default = enhance(ImageComponent);