'use strict';

exports.__esModule = true;
exports.Input = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _recompose = require('recompose');

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// @ts-check
var enhance = (0, _recompose.compose)((0, _recompose.setPropTypes)({
    submitHandler: _propTypes2.default.func,
    onKeyDown: _propTypes2.default.func
}), (0, _recompose.withState)('value', 'setValue', ''));

/**
 * A simple text Input component.
 * @param {Object} param
 * @param {string|number} param.value - the input's value.
 * @param {function(text: string)} param.submitHandler - submit handler function. This will send a message to the server using data supplied as parameter
 * @return {Object} React component
 */
var Input = exports.Input = function Input(_ref) {
    var submitHandler = _ref.submitHandler,
        _onKeyDown = _ref.onKeyDown,
        value = _ref.value,
        setValue = _ref.setValue;

    var _onClick = function _onClick(value) {
        submitHandler(value);
        setValue('');
    };
    return _react2.default.createElement(
        'div',
        {
            className: 'Input',
            onKeyDown: function onKeyDown(event) {
                var success = _onKeyDown(event, value);
                if (success) {
                    setValue('');
                }
            }
        },
        _react2.default.createElement('input', {
            className: 'Input-input',
            type: 'text',
            value: value,
            onChange: function onChange(_ref2) {
                var value = _ref2.target.value;
                return setValue(value);
            }
        }),
        _react2.default.createElement(
            'button',
            {
                className: 'Input-send',
                onClick: function onClick() {
                    _onClick(value);
                    setValue('');
                }
            },
            'SEND'
        )
    );
};

exports.default = enhance(Input);