'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _recompose = require('recompose');

var _reactTransitionGroup = require('react-transition-group');

var _index = require('../Animation/index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createMarkup = function createMarkup(children, title) {
    var text = title ? '<h1 class="Text-h1">' + children + '</h1>' : children;
    return { __html: text };
}; //@ts-check


var enhance = (0, _recompose.compose)((0, _recompose.setPropTypes)({
    title: _propTypes2.default.string,
    isLocal: _propTypes2.default.bool
}));

/**
 * A simple text component for use inside messages.
 * @param {Object} param
 * @param {string} param.title - the text message's title.
 * @param {string} param.children - markdown-generated html to render.  
 * @return {Object} React component
 */
var Text = function Text(_ref) {
    var title = _ref.title,
        children = _ref.children,
        isLocal = _ref.isLocal;
    return _react2.default.createElement(
        _index.Fade,
        { 'in': true, appear: true },
        _react2.default.createElement('div', {
            className: 'Text ' + (isLocal ? 'is-local' : ''),
            dangerouslySetInnerHTML: createMarkup(children, title)
        })
    );
};

exports.default = enhance(Text);
module.exports = exports['default'];